package dao.specification;

import dao.indentAbstractDAO;
import entities.Indent;
import entities.Merchants;
import entities.Users;
import org.jetbrains.annotations.NotNull;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import static dao.specification.abstractDAO.Delete;
import static util.SQLDatabaseConnection.close;
import static util.SQLDatabaseConnection.getConnection;

public class indentDAO implements indentAbstractDAO {

    private Connection connection = null;
    private PreparedStatement preparedStatement = null;
    private ResultSet resultSet = null;

    @Override
    public int insert(@NotNull Indent indent) {
        int flag;
        //@FIXME 这个allPrice总价怎么用SQL跨表求和啊超
        String insert_sql = "insert into Indent(userID, merchantsID, allPrice, message, createDate) " +
                "values(?,?,?,?,getdate())";
        try {
            connection = getConnection();
            preparedStatement = connection.prepareStatement(insert_sql);

            preparedStatement.setObject(1, indent.getUserID());
            preparedStatement.setObject(2, indent.getMerchantsID());
            preparedStatement.setFloat(3, indent.getAllPrice());
            preparedStatement.setString(4, indent.getMessage());

            flag = preparedStatement.executeUpdate(insert_sql);

        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
            close(connection, preparedStatement, resultSet);
        }

        return flag;
    }

    @Override
    public int delete(@NotNull Indent indent) {
        String delete_sql = "delete from Indent where id = ?";
//        int flag;
//        try {
//            connection = getConnection();
//            preparedStatement = connection.prepareStatement(delete_sql);
//
//            preparedStatement.setLong(1, indent.getId());
//
//            flag = preparedStatement.executeUpdate(delete_sql);
//
//        } catch (SQLException e) {
//            throw new RuntimeException(e);
//        } finally {
//            close(connection, preparedStatement, resultSet);
//        }
        return Delete
                (connection, preparedStatement, resultSet, delete_sql, indent.getId());
    }

    @Override
    public int update(@NotNull Indent indent) {
        int flag;
        String update_sql = "update Indent " +
                "set userID = ?, merchantsID = ?, allPrice = ?, message = ?, " +
                "createDate = getdate() where id = ?";
        try {
            connection = getConnection();
            preparedStatement = connection.prepareStatement(update_sql);

            preparedStatement.setObject(1, indent.getUserID());
            preparedStatement.setObject(2, indent.getMerchantsID());
            preparedStatement.setFloat(3, indent.getAllPrice());
            preparedStatement.setString(4, indent.getMessage());
            preparedStatement.setLong(5, indent.getId());

            flag = preparedStatement.executeUpdate(update_sql);
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }

        return flag;
    }

    @Override
    public List<Indent> search(Indent indent) {
        List<Indent> list = new ArrayList<>();
        String selectAll_sql = "select * from Indent";

        try {
            connection = getConnection();
            preparedStatement = connection.prepareStatement(selectAll_sql);

            resultSet = preparedStatement.executeQuery(selectAll_sql);

            while (resultSet.next()) {
                indent = new Indent();
                SetAttribute(indent, resultSet);
                list.add(indent);
            }

        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
            close(connection, preparedStatement, resultSet);
        }

        return list;
    }

    @Override
    public Indent searchID(Long id) {
        Indent indent = null;
        String selectID_sql = "select * from Indent where id = ?";

        try {
            connection = getConnection();
            preparedStatement = connection.prepareStatement(selectID_sql);
            preparedStatement.setLong(1, id);
            preparedStatement.executeQuery(selectID_sql);

            while (resultSet.next()) {
                indent = new Indent();
                SetAttribute(indent, resultSet);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
            close(connection, preparedStatement, resultSet);
        }

        return indent;
    }

    private void SetAttribute(@NotNull Indent indent, @NotNull ResultSet rs) throws SQLException {
        indent.setId(rs.getLong("id"));
        indent.setUserID((Users) rs.getObject("userID"));
        indent.setMerchantsID((Merchants) rs.getObject("merchantsID"));
        indent.setAllPrice(rs.getFloat("allPrice"));
        indent.setMessage(rs.getString("message"));
        indent.setCreatedDate(rs.getDate("createDate"));
    }
}
